bcm_wimax module hangs when Sierra Wireless 250U Data Card removed

Bug #953494 reported by Jason Cline on 2012-03-12
24
This bug affects 2 people
Affects Status Importance Assigned to Milestone
linux (Ubuntu)
Medium
Chris J Arges
Lucid
Undecided
Unassigned
Precise
Medium
Chris J Arges
Quantal
Medium
Chris J Arges
linux-firmware-nonfree (Ubuntu)
Undecided
Unassigned
Lucid
Undecided
Unassigned
Precise
Undecided
Unassigned
Quantal
Undecided
Unassigned

Bug Description

On Lucid with the Natty backport kernel and also on the precise kernel the removal of the Sierra Wireless 250U Data Card causes both gnome and reboots to hang and a kernel trace to be displayed on the console. A work around was found by including the firmware found in the sprint developers pack in /lib/firmware. I did not see the same behavior on the current Lucid kernel, as a matter of fact, it appears to operate just fine with no firmware at all. Also of note, the firmware from http://code.google.com/p/bcm-wimax/ improved gnome/kernel stability but the device only works the first time it is plugged in, and modprobe hangs indefinitely when trying to remove the bcm_wimax module.

Work around:
http://whebsite.com/media/downloads/Sprint4GDeveloperPack-1.6.1.2.2.tar.gz
Unpack the above. Inside are "Rel_6.1.2.2_USB-Updated.zip" and "Sprint4GMBBUtilities.tar.gz"; unpack them. Find "macxvi.cfg-PowerSaveOff-Rel_6.1.2.2_USB-Updated" and "macxvi350.bin". Copy the former to "/lib/firmware/macxvi.cfg" and the latter to "/lib/firmware/macxvi200.bin" (note the name change!).

Trace:
Feb 19 09:32:24 my-laptop kernel: [47876.531582] ------------[ cut here ]------------
Feb 19 09:32:24 my-laptop kernel: [47876.531600] WARNING: at /build/buildd/linux-lts-backport-natty-2.6.38/net/core/dev.c:5013 rollback_registered_many+0x9d/0x290()
Feb 19 09:32:24 my-laptop kernel: [47876.531612] Hardware name: 4291AK7
Feb 19 09:32:24 my-laptop kernel: [47876.531617] Modules linked in: bcm_wimax(C) sierra usbserial uvcvideo videodev v4l2_compat_ioctl32 usbhid hid binfmt_misc joydev
ppdev snd_hda_codec_hdmi snd_hda_codec_conexant rfcomm sco arc4 bnep snd_hda_intel thinkpad_acpi l2cap snd_hda_codec iwlagn snd_hwdep ip6t_LOG snd_seq_midi snd_pcm nf_c
onntrack_ipv6 nf_defrag_ipv6 snd_rawmidi snd_seq_midi_event ipt_REJECT btusb iwlcore ipt_LOG mac80211 ipt_ULOG snd_seq snd_timer snd_seq_device bluetooth xt_limit xt_tc
pudp snd ipt_addrtype xt_owner xt_conntrack sdhci_pci psmouse ip6table_filter ip6_tables xt_state xt_helper nf_nat_tftp nf_conntrack_tftp nf_nat_irc nf_conntrack_irc nf
_nat_ftp nf_nat serio_raw nf_conntrack_ipv4 nf_defrag_ipv4 cfg80211 sdhci nf_conntrack_ftp snd_page_alloc nf_conntrack iptable_filter ip_tables x_tables soundcore nvram
 tpm_tis tpm tpm_bios lp parport sha256_generic aesni_intel cryptd aes_x86_64 aes_generic dm_crypt dm_raid45 xor i915 drm_kms_helper drm ahci i2c_algo_bit libahci e1000
e video [last unloaded:
Feb 19 09:32:24 my-laptop kernel: v4l2_compat_ioctl32]
Feb 19 09:32:24 my-laptop kernel: [47876.531834] Pid: 29, comm: khubd Tainted: G D C 2.6.38-13-generic #54~lucid1-Ubuntu
Feb 19 09:32:24 my-laptop kernel: [47876.531843] Call Trace:
Feb 19 09:32:24 my-laptop kernel: [47876.531860] [<ffffffff81064f2f>] ? warn_slowpath_common+0x7f/0xc0
Feb 19 09:32:24 my-laptop kernel: [47876.531873] [<ffffffff81064f8a>] ? warn_slowpath_null+0x1a/0x20
Feb 19 09:32:24 my-laptop kernel: [47876.531885] [<ffffffff814d33ed>] ? rollback_registered_many+0x9d/0x290
Feb 19 09:32:24 my-laptop kernel: [47876.531897] [<ffffffff814d3706>] ? unregister_netdevice_queue+0x96/0x100
Feb 19 09:32:24 my-laptop kernel: [47876.531909] [<ffffffff814d3890>] ? unregister_netdev+0x20/0x30
Feb 19 09:32:24 my-laptop kernel: [47876.531929] [<ffffffffa0545f36>] ? unregister_networkdev+0x56/0x60 [bcm_wimax]
Feb 19 09:32:24 my-laptop kernel: [47876.531947] [<ffffffffa054d191>] ? AdapterFree+0x81/0x160 [bcm_wimax]
Feb 19 09:32:24 my-laptop kernel: [47876.531961] [<ffffffffa0536ea8>] ? InterfaceAdapterFree+0x108/0x160 [bcm_wimax]
Feb 19 09:32:24 my-laptop kernel: [47876.531976] [<ffffffffa0536f71>] ? usbbcm_disconnect+0x71/0xa0 [bcm_wimax]
Feb 19 09:32:24 my-laptop kernel: [47876.531989] [<ffffffff814415ea>] ? usb_unbind_interface+0x5a/0x1a0
Feb 19 09:32:24 my-laptop kernel: [47876.532003] [<ffffffff813b8275>] ? __device_release_driver+0x75/0xe0
Feb 19 09:32:24 my-laptop kernel: [47876.532015] [<ffffffff813b83dd>] ? device_release_driver+0x2d/0x40
Feb 19 09:32:24 my-laptop kernel: [47876.532026] [<ffffffff813b73de>] ? bus_remove_device+0xae/0xf0
Feb 19 09:32:24 my-laptop kernel: [47876.532037] [<ffffffff813b5047>] ? device_del+0x127/0x1d0
Feb 19 09:32:24 my-laptop kernel: [47876.532051] [<ffffffff8143e320>] ? usb_disable_device+0x70/0x130
Feb 19 09:32:24 my-laptop kernel: [47876.532063] [<ffffffff814387e5>] ? usb_disconnect+0x95/0x130
Feb 19 09:32:24 my-laptop kernel: [47876.532074] [<ffffffff814387cf>] ? usb_disconnect+0x7f/0x130
Feb 19 09:32:24 my-laptop kernel: [47876.532085] [<ffffffff81438b83>] ? hub_port_connect_change+0x93/0xa20
Feb 19 09:32:24 my-laptop kernel: [47876.532097] [<ffffffff81439880>] ? hub_events+0x370/0x520
Feb 19 09:32:24 my-laptop kernel: [47876.532108] [<ffffffff81439a85>] ? hub_thread+0x55/0x190
Feb 19 09:32:24 my-laptop kernel: [47876.532121] [<ffffffff810871f0>] ? autoremove_wake_function+0x0/0x40
Feb 19 09:32:24 my-laptop kernel: [47876.532133] [<ffffffff81439a30>] ? hub_thread+0x0/0x190
Feb 19 09:32:24 my-laptop kernel: [47876.532143] [<ffffffff81086c86>] ? kthread+0x96/0xa0
Feb 19 09:32:24 my-laptop kernel: [47876.532155] [<ffffffff8100cea4>] ? kernel_thread_helper+0x4/0x10
Feb 19 09:32:24 my-laptop kernel: [47876.532166] [<ffffffff81086bf0>] ? kthread+0x0/0xa0

Feb 19 09:32:24 my-laptop kernel: [47876.532189] [<ffffffff8100cea0>] ? kernel_thread_helper+0x0/0x10
Feb 19 09:32:24 my-laptop kernel: [47876.532203] ---[ end trace cf4de0d90abeb20c ]---
Feb 19 09:32:24 my-laptop kernel: [47876.700873] PGD 0
Feb 19 09:32:24 my-laptop kernel: [47876.710544] CPU 0
Feb 19 09:32:24 my-laptop kernel: [47876.710574] Modules linked in: bcm_wimax(C) sierra usbserial uvcvideo videodev v4l2_compat_ioctl32 usbhid hid binfmt_misc joydev ppdev snd_hda_codec_hdmi snd_hda_codec_conexant rfcomm sco arc4 bnep snd_hda_intel thinkpad_acpi l2cap snd_hda_codec iwlagn snd_hwdep ip6t_LOG snd_seq_midi snd_pcm nf_conntrack_ipv6 nf_defrag_ipv6 snd_rawmidi snd_seq_midi_event ipt_REJECT btusb iwlcore ipt_LOG mac80211 ipt_ULOG snd_seq snd_timer snd_seq_device bluetooth xt_limit xt_tcpudp snd ipt_addrtype xt_owner xt_conntrack sdhci_pci psmouse ip6table_filter ip6_tables xt_state xt_helper nf_nat_tftp nf_conntrack_tftp nf_nat_irc nf_conntrack_irc nf_nat_ftp nf_nat serio_raw nf_conntrack_ipv4 nf_defrag_ipv4 cfg80211 sdhci nf_conntrack_ftp snd_page_alloc nf_conntrack iptable_filter ip_tables x_tables soundcore nvram tpm_tis tpm tpm_bios lp parport sha256_generic aesni_intel cryptd aes_x86_64 aes_generic dm_crypt dm_raid45 xor i915 drm_kms_helper drm ahci i2c_algo_bit libahci e1000e video [last unloaded:
Feb 19 09:32:24 my-laptop kernel: v4l2_compat_ioctl32]
Feb 19 09:32:24 my-laptop kernel: [47876.735522]
Feb 19 09:32:24 my-laptop kernel: [47876.739197] Pid: 29, comm: khubd Tainted: G D WC 2.6.38-13-generic #54~lucid1-Ubuntu LENOVO 4291AK7/4291AK7Feb 19 09:32:24 my-laptop kernel: [47876.743090] RIP: 0010:[<ffffffff81599472>] [<ffffffff81599472>] packet_notifier+0x52/0x1e0
Feb 19 09:32:24 my-laptop kernel: [47876.746847] RSP: 0018:ffff88020b39f980 EFLAGS: 00010206
Feb 19 09:32:24 my-laptop kernel: [47876.750585] RAX: ffff88020b39fe60 RBX: 0000000000000018 RCX: ffffffff81a96b00
Feb 19 09:32:24 my-laptop kernel: [47876.754275] RDX: ffff88020b39f9c0 RSI: 0000000000000011 RDI: ffffffff81a96b00
Feb 19 09:32:24 my-laptop kernel: [47876.757725] RBP: ffff88020b39f9b0 R08: 0000000000000000 R09: 0000000000000001
Feb 19 09:32:24 my-laptop kernel: [47876.761169] R10: 0000000000000000 R11: 00000000ffffffff R12: 0000000000000011
Feb 19 09:32:24 my-laptop kernel: [47876.764441] R13: ffff88020b39f9c0 R14: 0000000000000000 R15: ffffffffa01e5040
Feb 19 09:32:24 my-laptop kernel: [47876.767656] FS: 0000000000000000(0000) GS:ffff8800da600000(0000) knlGS:0000000000000000
Feb 19 09:32:24 my-laptop kernel: [47876.770822] CS: 0010 DS: 0000 ES: 0000 CR0: 000000008005003b
Feb 19 09:32:24 my-laptop kernel: [47876.773914] CR2: 0000000000000018 CR3: 0000000001a03000 CR4: 00000000000406f0
Feb 19 09:32:24 my-laptop kernel: [47876.777068] DR0: 0000000000000000 DR1: 0000000000000000 DR2: 0000000000000000
Feb 19 09:32:24 my-laptop kernel: [47876.780232] DR3: 0000000000000000 DR6: 00000000ffff0ff0 DR7: 0000000000000400
Feb 19 09:32:24 my-laptop kernel: [47876.783361] Process khubd (pid: 29, threadinfo ffff88020b39e000, task ffff88020dfadb80)

Feb 19 09:32:24 my-laptop kernel: [47876.789712] ffff88020b39f990 0000000000000011 ffff88020b39f9c0 00000000fffffff4
Feb 19 09:32:24 my-laptop kernel: [47876.792944] 0000000000000000 ffffffffa01e5040 ffff88020b39f9f0 ffffffff815cb176
Feb 19 09:32:24 my-laptop kernel: [47876.796287] ffff88020b39fa10 0000000000000011 ffff88020b39f9c0 ffff880181fc0000
Feb 19 09:32:24 my-laptop kernel: [47876.802760] [<ffffffff815cb176>] notifier_call_chain+0x56/0x80
Feb 19 09:32:24 my-laptop kernel: [47876.806097] [<ffffffff8108cb16>] raw_notifier_call_chain+0x16/0x20
Feb 19 09:32:24 my-laptop kernel: [47876.809337] [<ffffffff814d2ac7>] call_netdevice_notifiers+0x37/0x70
Feb 19 09:32:24 my-laptop kernel: [47876.812581] [<ffffffff814d354b>] rollback_registered_many+0x1fb/0x290
Feb 19 09:32:24 my-laptop kernel: [47876.815965] [<ffffffff814d3706>] unregister_netdevice_queue+0x96/0x100
Feb 19 09:32:24 my-laptop kernel: [47876.819226] [<ffffffff814d3890>] unregister_netdev+0x20/0x30
Feb 19 09:32:24 my-laptop kernel: [47876.822465] [<ffffffffa0545f36>] unregister_networkdev+0x56/0x60 [bcm_wimax]

Feb 19 09:32:24 my-laptop kernel: [47876.825841] [<ffffffffa054d191>] AdapterFree+0x81/0x160 [bcm_wimax]
Feb 19 09:32:24 my-laptop kernel: [47876.829128] [<ffffffffa0536ea8>] InterfaceAdapterFree+0x108/0x160 [bcm_wimax]
Feb 19 09:32:24 my-laptop kernel: [47876.832436] [<ffffffffa0536f71>] usbbcm_disconnect+0x71/0xa0 [bcm_wimax]
Feb 19 09:32:24 my-laptop kernel: [47876.835850] [<ffffffff814415ea>] usb_unbind_interface+0x5a/0x1a0
Feb 19 09:32:24 my-laptop kernel: [47876.839171] [<ffffffff813b8275>] __device_release_driver+0x75/0xe0
Feb 19 09:32:24 my-laptop kernel: [47876.842586] [<ffffffff813b83dd>] device_release_driver+0x2d/0x40
Feb 19 09:32:24 my-laptop kernel: [47876.845913] [<ffffffff813b73de>] bus_remove_device+0xae/0xf0
Feb 19 09:32:24 my-laptop kernel: [47876.849231] [<ffffffff813b5047>] device_del+0x127/0x1d0
Feb 19 09:32:24 my-laptop kernel: [47876.852646] [<ffffffff8143e320>] usb_disable_device+0x70/0x130
Feb 19 09:32:24 my-laptop kernel: [47876.855939] [<ffffffff814387e5>] usb_disconnect+0x95/0x130
Feb 19 09:32:24 my-laptop kernel: [47876.859175] [<ffffffff814387cf>] usb_disconnect+0x7f/0x130
Feb 19 09:32:24 my-laptop kernel: [47876.862462] [<ffffffff81438b83>] hub_port_connect_change+0x93/0xa20
Feb 19 09:32:24 my-laptop kernel: [47876.865711] [<ffffffff81439880>] hub_events+0x370/0x520
Feb 19 09:32:24 my-laptop kernel: [47876.868880] [<ffffffff81439a85>] hub_thread+0x55/0x190
Feb 19 09:32:24 my-laptop kernel: [47876.872033] [<ffffffff810871f0>] ? autoremove_wake_function+0x0/0x40
Feb 19 09:32:24 my-laptop kernel: [47876.875025] [<ffffffff81439a30>] ? hub_thread+0x0/0x190
Feb 19 09:32:24 my-laptop kernel: [47876.877905] [<ffffffff81086c86>] kthread+0x96/0xa0
Feb 19 09:32:24 my-laptop kernel: [47876.880751] [<ffffffff8100cea4>] kernel_thread_helper+0x4/0x10
Feb 19 09:32:24 my-laptop kernel: [47876.883446] [<ffffffff81086bf0>] ? kthread+0x0/0xa0
Feb 19 09:32:24 my-laptop kernel: [47876.886010] [<ffffffff8100cea0>] ? kernel_thread_helper+0x0/0x10
Feb 19 09:32:24 my-laptop kernel: [47876.896912] RSP <ffff88020b39f980>
Feb 19 09:32:24 my-laptop kernel: [47876.902378] ---[ end trace cf4de0d90abeb20d ]---
Feb 19 09:35:57 my-laptop kernel: Kernel logging (proc) stopped.

lsb_release -rd
Description: Ubuntu 10.04.3 LTS
Release: 10.04

Packages of interest:
linux-image-generic-lts-backport-natty 2.6.38.13.23
linux-firmware 1.34.13

Jason Cline (jcline) wrote :
Jason Cline (jcline) wrote :
Chris J Arges (arges) on 2012-03-19
affects: linux-meta-lts-backport-natty (Ubuntu) → linux (Ubuntu)

This bug is missing log files that will aid in diagnosing the problem. From a terminal window please run:

apport-collect 953494

and then change the status of the bug to 'Confirmed'.

If, due to the nature of the issue you have encountered, you are unable to run this command, please add a comment stating that fact and change the bug status to 'Confirmed'.

This change has been made by an automated script, maintained by the Ubuntu Kernel Team.

Changed in linux (Ubuntu):
status: New → Incomplete
tags: added: natty
Chris J Arges (arges) wrote :

Hello, can you please run "apport-collect -p linux 953494" when running a clean, updated precise. This will attach existing logs to the bug which will be helpful in debugging this issue.
Thanks

Changed in linux (Ubuntu):
assignee: nobody → Chris J Arges (christopherarges)
status: Incomplete → Triaged

I know apport-collect is now SOP to insert a delay into the processing of every bug, but I do think it's perfectly clear what's going on here.

Chris J Arges (arges) on 2012-03-20
tags: added: bot-stop-nagging precise
komputes (komputes) on 2012-03-20
tags: added: css-sponsored-p
Chris J Arges (arges) wrote :

Thomas,
Hello. I just wanted to confirm which version of linux-firmware you were using in Precise, and also which modules were loaded.
However, if you can just confirm the following it may be enough information:

* Using the Lucid kernel:
Do you need to also install the external bcm_wimax module to get this working, or does this work out of the box?

* Using Natty or Precise kernel:
I see the bcm driver in drivers/staging/bcm is looking for the following files:
#define BIN_FILE "/lib/firmware/macxvi200.bin"
#define CFG_FILE "/lib/firmware/macxvi.cfg"
However looking at linux-firmware package I don't see any files by that name that get installed.
So it would make sense if _just_ installing those firmware files into /lib/firmware potentially fixed the issue.

Does the device work fine when just installing those two firmware files?

Thanks,

Chris, I will let Thomas or someone else affected confirm or infirm this, but from what I gather from the description, using the lucid 2.6.32 kernel, it just work out of the box without having to manually add any firmware files. Moreover, installing the two files in question (macxvi200.bin and macxvi.cfg) appears to be all that is needed to make the adapter work properly on linux-image-generic-lts-backport-natty 2.6.38.13.23.

Can Thomas or Jason confirm this?

Changed in linux (Ubuntu Precise):
importance: Undecided → Medium
Jason Cline (jcline) wrote :

The lucid 2.6.32 kernel appears to work fine out of the box. Not so with the last precise install I tried though. Same symptoms.

Jason Cline (jcline) wrote :

Both linux-image-generic-lts-backport-natty on lucid, and precise with linux-image-generic 3.2.0.24.26 seem to work fine with the firmware available here http://www6.sprint.com/downloads/sprint_smartview/executables/SSV_Windows2.50.0094.exe without renaming the macxvi* files.

The .exe Jason refer to is the Windows driver for that adapter. It can be downloaded without a registration, unlike the Developer Pack discussed in the bug description. The .exe is actually a self-extracting zip file, and the firmware files (macxvi200.bin and .cfg) are in ./CommonAppData/Sprint/Sprint SmartView/drivers/wimax/xp/32Bit/Beceem/Beceem 5.2.6.8_P3/.

Tim Gardner (timg-tpi) on 2012-05-16
Changed in linux-firmware-nonfree (Ubuntu Lucid):
status: New → Fix Committed
Tim Gardner (timg-tpi) on 2012-05-16
Changed in linux-firmware-nonfree (Ubuntu Precise):
status: New → Fix Committed
Changed in linux-firmware-nonfree (Ubuntu Quantal):
status: New → Fix Committed
Changed in linux (Ubuntu Lucid):
status: New → Invalid
Changed in linux (Ubuntu Precise):
status: Triaged → Invalid
Changed in linux (Ubuntu Quantal):
status: Triaged → Invalid
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package linux-firmware-nonfree - 1.12

---------------
linux-firmware-nonfree (1.12) quantal; urgency=low

  * Added Beceem wimax firmware used by kernel versions 3.0 and higher.
    -LP: #953494
 -- Tim Gardner <email address hidden> Wed, 16 May 2012 13:41:06 -0600

Changed in linux-firmware-nonfree (Ubuntu Quantal):
status: Fix Committed → Fix Released

Hello Jason, or anyone else affected,

Accepted linux-firmware-nonfree into precise-proposed. The package will build now and be available in a few hours. Please test and give feedback here. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Thank you in advance!

Martin Pitt (pitti) wrote :

Hello Jason, or anyone else affected,

Accepted linux-firmware-nonfree into lucid-proposed. The package will build now and be available in a few hours. Please test and give feedback here. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Thank you in advance!

Jason Cline (jcline) wrote :

Enabling proposed and installing linux-firmware-nonfree seemed to do the trick. The device works, and no crashes on removal.

Jason Cline (jcline) wrote :

More specifically on lucid with the natty backports kernel.

Elizabeth K. Joseph (lyz) wrote :

Just installed the precise-proposed version of linux-firmware-nonfree on precise and I can now safely remove the device without a crash. Thanks!

Chris J Arges (arges) on 2012-05-29
tags: added: lucid
Stéphane Graber (stgraber) wrote :

Based on the two comments above, that sounds like a pass on both lucid and precise.

tags: added: verification-done
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package linux-firmware-nonfree - 1.11ubuntu1

---------------
linux-firmware-nonfree (1.11ubuntu1) precise-proposed; urgency=low

  * Added Beceem wimax firmware used by kernel versions 3.0 and higher.
    -LP: #953494
 -- Tim Gardner <email address hidden> Wed, 16 May 2012 13:33:40 -0600

Changed in linux-firmware-nonfree (Ubuntu Precise):
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package linux-firmware-nonfree - 1.8ubuntu1

---------------
linux-firmware-nonfree (1.8ubuntu1) lucid-proposed; urgency=low

  * Added Beceem wimax firmware used by kernel versions 3.0 and higher.
    This firmware will be used by LTS backport kernels.
    -LP: #953494
 -- Tim Gardner <email address hidden> Wed, 16 May 2012 13:23:51 -0600

Changed in linux-firmware-nonfree (Ubuntu Lucid):
status: Fix Committed → Fix Released
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers